<template>

  <div>
    <!-- Page title -->
    <h1>{{ $t('views.VerifyEmail.title') | capitalize }}</h1>

    <!-- Verification indicator -->
    <div class="bg-secondary rounded-lg p-4">

      <!-- Being verified -->
      <p v-if="verifyEmailLoading">
        {{ $t('views.VerifyEmail.beingVerified') | capitalize }}
        <LoadingIcon class="inline-block"/>
      </p>

      <!-- Verified: success -->
      <div v-if="emailVerified || (!verifyEmailLoading && responseStatus)">
        <p class="mb-4">
          {{ $t('views.VerifyEmail.success') | capitalize }}
          <br>
          <i18n path="views.VerifyEmail.redirectMessage">
            <!-- ref {0} -->
            {{ timeRemaining }}
          </i18n>
        </p>
        <Button variant="action" @click.native="redirect">
          {{ $t('global.continue') | capitalize }}
        </Button>
      </div>

      <!-- Error -->
      <div v-if="!emailVerified && !verifyEmailLoading && !responseStatus">
        <p class="text-error mb-4">
          <v-icon name="exclamation-triangle"/>
          {{ $t('errors.e0040') }}
        </p>
        <Button
          variant="action"
          @click.native="resendEmailConfirmationLink"
        >
          <v-icon name="redo-alt"/> {{ $t('user.resendEmailConfirmationLink') | capitalize }}
        </Button>
      </div>

    </div>

  </div>
</template>

<script>
// vuex helpers
import { mapState, mapActions } from 'vuex'
/**
 * VerifyEmail component
 */
export default {
  name: 'VerifyEmail',
  data () {
    return {
      emailVerified: null,
      hash: null,
      expires: null,
      signature: null,
      responseStatus: false, // Default to false
      countDown: null, // Default to null
      timeRemaining: 10 // Default to 10 seconds
    }
  },
  computed: {
    // Map state from 'Users' store module
    ...mapState('Users', [
      'verifyEmailLoading'
    ])
  },
  methods: {
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'verifyEmail',
      'resendEmailVerificationLink'
    ]),
    /**
     * Handle click on 'resend email link' button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    async resendEmailConfirmationLink (evt) {
      evt.preventDefault()
      // Wait for resendEmailVerificationLink function
      const response = await this.resendEmailVerificationLink({ userId: this.$root.auth.user().id })
      // If passed
      if (!(response instanceof Error)) {
        // Show popup
        this.$store.commit('SET_SYSTEM_SHOW_EMAIL_SENT_MODAL', true)
      // Else parse server error
      } else {
        this.throwSystemError(this.$t('errors.e0010'))
      }
    },
    /**
     * Start countdown before redirect
     * @return {void}
     */
    startCountDown () {
      this.countDown = setInterval(() => {
        this.timeRemaining -= 1
        // If the count down is finished
        if (this.timeRemaining < 1) {
          clearInterval(this.countDown)
        }
      }, 1000) // Every 1 second (1000 ms)
    },
    /**
     * redirect method
     * @return {void}
     */
    redirect () {
      window.location = '/'
    }
  },
  async mounted () {
    // Check if user has email verified
    this.emailVerified = this.$root.auth.user().emailVerifiedAt
    if (!this.emailVerified) {
      // Get hash param
      this.hash = this.$route.params.hash
      // Get query param 'expires'
      this.expires = this.$route.query.expires
      // Get query param 'signature'
      this.signature = this.$route.query.signature
      // Wait for verify email function
      const verifyEmailResponse = await this.verifyEmail({
        userId: this.$root.auth.user().id,
        hash: this.hash,
        query: {
          expires: this.expires,
          signature: this.signature
        }
      })
      // If success
      if (!(verifyEmailResponse instanceof Error)) {
        this.responseStatus = true
        this.emailVerified = true
      } else {
        this.responseStatus = false
        this.throwSystemError(this.$t('errors.e0040'))
      }
    }
  },
  watch: {
    // Watch emailVerified to trigger countdown
    emailVerified: function (to, from) {
      // If email is verified -> start countdown to redirect user
      if (to) {
        this.startCountDown()
      }
    },
    // Watch timeRemaining to redirect user
    timeRemaining: function (to, from) {
      // When timeRemaining equals to 0 -> redirect to home
      if (to === 0) {
        this.redirect()
      }
    }
  }
}
</script>
